<?php
// Wartet auf "+OK", oder "-ERR"
function pop3_wait4result( $handle )
{
	while( $wait_result = fgets( $handle, 256 ) )
	{
		if( substr( $wait_result, 0, 1 ) == "-" )
			return $wait_result;
		if( substr( $wait_result, 0, 1 ) == "+" )
			return $wait_result;
	}
}

// Lade Status der POP3 Mailbox
function pop3_getstat( $addr, $port, $user, $pass, $timeout, $quit_handle )
{
	// RETURN ARRAY POP3_GETSTAT
	$stat_array = 	array( 	"handle" => @fsockopen( $addr, $port, $errno, $errstr, $timeout ),
				"init" => FALSE,
				"user" => FALSE,
				"pass" => FALSE,
				"status" => FALSE );

	// BENUTZE HANDLE BIS STAT
	if( $stat_array[ "handle" ] )
        {
		socket_set_timeout( $stat_array[ "handle" ], $timeout );
		// Connect Antwort laden
		$stat_array[ "init" ] = pop3_wait4result( $stat_array[ "handle" ] );
		// Benutzer senden
		fputs( $stat_array[ "handle" ], "USER $user\r\n" );
		$stat_array[ "user" ] = pop3_wait4result( $stat_array[ "handle" ] );
		// Passwort senden
		fputs( $stat_array[ "handle" ], "PASS $pass\r\n" );
		$stat_array[ "pass" ] = pop3_wait4result( $stat_array[ "handle" ] );
		// Status abfragen
		fputs( $stat_array[ "handle" ], "STAT\r\n" );
		$stat_array[ "status" ] = pop3_wait4result( $stat_array[ "handle" ] );
		// Handle schlieen
		if( $quit_handle )
		{
			fputs( $stat_array[ "handle" ], "QUIT\r\n" );
			$stat_array[ "handle" ] = fgets( $stat_array[ "handle" ] );
		}
	} else $stat_array[ "handle" ] = FALSE;

	return $stat_array;
}

// Liste der Mails abrufen
function pop3_getmessagelist( $handle, $quit_handle )
{
	// RETURN ARRAY GET_MESSAGELIST
	$messagelist_arr = 	array( 0 => array( "message_nr" => FALSE, "message_size" => FALSE ) );

	fputs( $handle, "LIST\r\n" );
	$list_return = pop3_wait4result( $handle );
	if( strstr( $list_return, "+OK" ) )
	{
		$i = 0;
		while( $list_return = fgets( $handle ) )
		{
			if( !strstr( $list_return, "." ) )
			{
				$list_return_arr = explode( " ", $list_return );
				$messagelist_arr[ $i ][ "message_nr" ] = $list_return_arr[ 0 ];
				$messagelist_arr[ $i ][ "message_size" ] = $list_return_arr[ 1 ];
				$i++;
			}
			else break;
		}
	}

	// Handle schlieen
	if( $quit_handle )
	{
		fputs( $handle, "QUIT\r\n" );
		$handle = fgets( $handle );
	}

	return $messagelist_arr;
}

// Liste der Mails abrufen
function pop3_getsubjectlist( $handle, $messagelist_arr, $quit_handle )
{
	// RETURN ARRAY GET_MESSAGELIST
	$subjectlist_arr = 	array( 0 => array( "message_nr" => FALSE, "message_from" => FALSE, "message_subject" => FALSE ) );

	$i = 0;
	$j = 0;
	while( $message_nr = $messagelist_arr[ $i ][ "message_nr" ] )
	{
		fputs( $handle, "TOP $message_nr 0\r\n" );
		$list_return = pop3_wait4result( $handle );
		if( strstr( $list_return, "+OK" ) )
		{
			$subjectlist_arr[ $j ][ "message_nr" ] = $message_nr;
			while( $header_return = fgets( $handle ) )
			{
				if( substr( $header_return, 0, 1 ) != "." )
				{
					$header_return_arr = explode( ": ", $header_return, 2 );
					if( $header_return_arr[ 0 ] == "From" )
						$subjectlist_arr[ $j ][ "message_from" ] = $header_return_arr[ 1 ];
					if( $header_return_arr[ 0 ] == "Subject" )
						$subjectlist_arr[ $j ][ "message_subject" ] = $header_return_arr[ 1 ];
				}
				else break;
			}
			$j++;
		} else break;
		$i++;
	}

	// Handle schlieen
	if( $quit_handle )
	{
		fputs( $handle, "QUIT\r\n" );
		$handle = fgets( $handle );
	}

	return $subjectlist_arr;
}

// Ld Message vom POP3 Server, Body und Header getrennt
function pop3_getmessage( $handle, $message_nr, $quit_handle )
{
	$message_arr =	array( "message_nr" => FALSE, "message_header" => FALSE, "message_body" => FALSE );
	$header_complete = FALSE;

	fputs( $handle, "RETR $message_nr\r\n" );
	$retr_return = pop3_wait4result( $handle );
	if( strstr( $retr_return, "+OK" ) )
	{
		$message_arr[ "message_nr" ] = $message_nr;
		while( $retr_return = fgets( $handle ) )
		{
			if( substr( $retr_return, 0, 1 ) != "." )
			{
				// Erste Leerzeile Kennzeichen fr Header Ende
				if( $retr_return == "\r\n" || $retr_return == "\n\r" )
					$header_complete = TRUE;
				// Header und Body laden
				if( $header_complete )
				{
					$message_arr[ "message_body" ] .= $retr_return;
				}
				else
				{
					$message_arr[ "message_header" ] .= $retr_return;
				}
			}
			else break;
		}
	}

	// Handle schlieen
	if( $quit_handle )
	{
		fputs( $handle, "QUIT\r\n" );
		$handle = fgets( $handle );
	}

	return $message_arr;
}

// Verbindung beenden
function pop3_quit( $handle )
{
	fputs( $handle, "QUIT\r\n" );
	$handle = fgets( $handle );
	return TRUE;
}

// bersetze STAT-Array in lesbares Format
function pop3_parse_stat( $stat_array )
{
	// RETURN ARRAY PARSE_STAT
	$parse_stat_arr = 	array(	"mails" => FALSE,	"size" => FALSE );

	// Nur parsen, wenn Handle geffnet, oder erfolgreich geschlossen
	if( $stat_array[ "handle" ] )
	{
		$parse_arr = explode( " ", $stat_array[ "status" ] );
		$parse_stat_arr[ "mails" ] = $parse_arr[ 1 ];
		$parse_stat_arr[ "size" ] = $parse_arr[ 2 ];
	}
	return $parse_stat_arr;
}
?>