// Webclient - Daten an PHP-Skript senden
// Datei: buch3_kap10_ethernet_webclient.ino
// Datum: 22.06.12


#include <SPI.h>
#include <Ethernet.h>

// Ethernet Konfiguration
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
byte ip[] = { 10, 0, 1, 144 };
byte gateway[] = { 10, 0, 1, 1 };
byte subnet[] = { 255, 255, 255, 0 };

// IP des externen Servers
IPAddress server(111, 222, 222, 111);

EthernetClient client;

long updateTimer;
boolean clientConnected = false;

float tempC;

void setup()
{
  Serial.begin(9600);
  Serial.println("Start...");
}

void loop()
{
  // Daten senden
  SendenDaten();
  // Status HTTP-Request einlesen
  checkStatus();
}

void SendenDaten()
{
  tempC=23.44;
  if ((millis() - updateTimer) > 10000)
  {
    Ethernet.begin(mac, ip);
    Serial.println("connecting...");
    delay(1000);
    if (client.connect(server, 80))
    {
      Serial.println("connected");
      client.print("GET /temperatur.php?t=");
      client.print(tempC);
      client.println(" HTTP/1.0");
      client.println("HOST:meinserver.com");
      client.println();
      client.println();
      clientConnected = true;
    }
    else
    {
	Serial.println("connection failed");
    }
    updateTimer = millis();
  }
}

void checkStatus()
{
  if (clientConnected)
  {
    if (client.available())
    {
	char c = client.read();
	Serial.print(c);
    }
    if (!client.connected())
    {
	Serial.println();
	Serial.println("disconnecting.");
	client.stop();
	clientConnected = false;
    }
  }
}
