//
// Einfacher Webserver mit Temperaturanzeige
// Datei: buch3_kap10_ethernet_webserver.ino
// Datum: 13.02.2010/TB

#include <SPI.h>
#include <Ethernet.h>

// Ethernet Konfiguration
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
byte ip[] = { 192, 168, 1, 199 };

// Server-Objekt mit Standardport 80
EthernetServer server(80);

// Variablen Temperatursensor LM35
float tempC;
int tempPin = 0;

void setup() {
  // Ethernet Initialisierung
  Ethernet.begin(mac, ip);
  // Server bereit, wartet auf anfragen
  server.begin();
}
 
void loop()
{
  EthernetClient client = server.available();
  if (client)
  { 
    server.println("HTTP/1.1 200 OK");
    server.println("Content-Type: text/html");
    server.println();
    server.print("<HTML><HEAD><TITLE>");
    server.print("Arduino Board");
    server.print("</TITLE>");
    server.print("</HEAD><BODY>");
    server.print("<h1>Mein Arduino-Board</h1>");
    server.print("Zimmertemperatur: ");
    // Temperatur messen
    tempC = analogRead(tempPin);
    tempC = (5.0 * tempC * 100.0)/1024.0;
    // Ausgabe der Temperatur
    server.print(tempC);
    server.print(" Grad C");
    server.println("<br />");
    server.println("<hr />");   
    server.print("Arduino läuft seit ");
    server.print(millis());
    server.print(" ms.");
    server.print("</BODY></HTML>");
    delay(10); 
    client.stop();
  }
}
