//
// Ethernet - Mailsenden
// Datei: buch3_kap10_mailsenden_direkt.ino
// Datum: 23.07.2014

#include <SPI.h>
#include <Ethernet.h>

// Ethernet Einstellungen
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
byte ip[] = { 192, 168, 1, 199 };        // IP Arduino Board
byte gateway[] = { 192, 168, 1, 1 };     // IP Router
byte subnet[] = { 255, 255, 255, 0 };

// IP des externen Servers
byte server[] = {192, 168, 1, 10};

EthernetClient client;


void setup()
{
 Ethernet.begin(mac, ip);
 Serial.begin(9600);

 delay(1000);

 Serial.println("connecting...");

 if (client.connect(server, 25))
 {
   Serial.println("connected");
   // Text nach HELO nicht relevant
   client.println("HELO HalloServer");
   client.println("MAIL FROM: meineemail@email.com");
   client.println("RCPT TO: empfangsadresse@email.com");
   client.println("DATA");
   // Absender-Adresse
   client.println("From: meineemail@email.com");
   // Empfänger-Adresse
   client.println("To: empfangsadresse@email.com");
   // Titel des Mails
   client.println("Subject: Arduino sendet Email");
   client.println();
   // Inhaltstext des Mails
   client.println("Das ist der Inhalt vom Mail von Arduino.");
   // Kennzeichnung Ende des Emails
   client.println(".");
   // Abmelden
   client.println("QUIT");
 } else {
   Serial.println("connection failed");
 }
}

void loop()
{
 if (client.available()) {
   char c = client.read();
   Serial.print(c);
 }

 if (!client.connected()) {
   Serial.println();
   Serial.println("disconnecting.");
   client.stop();
   for(;;)
     ;
 }
} 


