//
// Umweltsensor DHT22
// Datei: buch3_kap5_dht33.ino
// Board: Arduino Uno
// Datum: 04.06.2014


// Example testing sketch for various DHT humidity/temperature sensors
// Written by ladyada, public domain

#include "DHT.h"

// Data Pin 
#define DHTPIN 2 

// Auswahl Sensor Typ
//#define DHTTYPE DHT11   // DHT 11 
#define DHTTYPE DHT22   // DHT 22  (AM2302)
//#define DHTTYPE DHT21   // DHT 21 (AM2301)

// Sensor Objekt erstellen
DHT dht(DHTPIN, DHTTYPE);

void setup() {
  Serial.begin(9600); 
  Serial.println("DHTxx Temp/Humidity Sensor");
  dht.begin();
}

void loop()
{
  // Sensor einlesen
  // Luftfeuchtigkeit
  float h = dht.readHumidity();
  // Temperatur
  float t = dht.readTemperature();

  // Prüfen ob richtiger Rückgabewert
  if (isnan(t) || isnan(h))
  {
    Serial.println("Fehler beim Zugriff auf DHT");
  }
  else
  {
    // Ausgabe Daten
    Serial.print("Luftfeuchtigkeit: "); 
    Serial.print(h);
    Serial.print("% / ");
    Serial.print("Temperatur: "); 
    Serial.print(t);
    Serial.println(" Grad C");
  }
}
