//
// Temperatursensor K-Typ mit MAX6675
// Datei: buch3_kap5_max6675.ino
// Datum: 16.04.2011/TB


#include "max6675.h"

// Ports für Ansteuerung von MAX6675
int thermoDO = 4;   // Data
int thermoCS = 5;   // Chip Select
int thermoCLK = 6;  // Clock 

// Thermoelement Objekt erstellen
MAX6675 Thermo(thermoCLK, thermoCS, thermoDO);

// Port für Spannungsversorgung
int vccPin = 3;
int gndPin = 2;
  
void setup() 
{
  Serial.begin(9600);
  // Falls Arduino Ports zur Spannungsversorgung 
  pinMode(vccPin, OUTPUT);
  digitalWrite(vccPin, HIGH);
  pinMode(gndPin, OUTPUT);
  digitalWrite(gndPin, LOW);
   Serial.println("Temperatur mit MAX6675");
  // Stabilisierungsphase
  delay(500);
}

void loop()
{
  // Ausgabe auf der seriellen Schnittstelle
  Serial.print("Temp C: ");
  Serial.println(Thermo.readCelsius());
  Serial.print("Temp F: ");
  Serial.println(Thermo.readFahrenheit());
  delay(1000);
}
