//
// Hall Sensor - Bike Speedmeter mit Anzeige
// Datei: buch3_kap7_speedmeter.ino
// Datum: 14.06.14

#include <PCD8544.h>

static PCD8544 lcd;

int irqPin = 2;

float umdreh;
float anz;
float rpm;
float spd;
float dist;

unsigned long timeold;

float WHEELCIRC = 2.0736;  // (2 * PI * 0.3302 in m)

void setup()
{
  Serial.begin(9600);
  // Interrupt Pull-up
  digitalWrite(irqPin, HIGH);
  // Interrupt
  attachInterrupt(0, count_umd, FALLING);
  // Display
  lcd.begin(84, 48);
  lcd.setCursor(0, 0);
  lcd.print("BIKESPEED V1");
  // Data
  umdreh = 0;
  rpm = 0;
  timeold = 0;
  dist=0;
}

void loop()
{
  lcd.setCursor(0, 0);
  lcd.print("BIKESPEED V1");
  if (umdreh >= 3)
  { 
    // Berechnungen:
    int timediff=millis()-timeold;
    rpm = anz/timediff;
    // Geschwindigkeit
    spd = (rpm * WHEELCIRC * 3600);
    // Distanz
    dist = dist + (anz * WHEELCIRC);
   
    // Ausgabe Serial Monitor
    Serial.print("Speed:");
    Serial.print(spd,1);
    Serial.println(" km/h");
    Serial.print("Distance:");
    Serial.print(dist/1000,3);
    Serial.println(" m");
    timeold = millis();
    umdreh = 0;
  }
  
  // Ausgabe Display
  lcd.setCursor(0, 1);
  lcd.print("G: ");
  lcd.setCursor(20, 1);
  lcd.print(spd,1);
  lcd.setCursor(50, 1);
  lcd.print("(km/h)");
  lcd.setCursor(0, 2);
  lcd.print("D: ");
  lcd.print(dist/1000,3);
  lcd.setCursor(50, 2);
  lcd.print("(km)");
 }


void count_umd()
{
  umdreh=umdreh+1;
  anz=umdreh;
}

