// Beispiel für SoftwareSerial und TinyGPS
// Datei: buch3_kap9_example_tinygps.ino
// Datum: 12.01.15


#include <SoftwareSerial.h>
#include <TinyGPS.h>

// GPS-Objekt
TinyGPS gps;
// Zusätzliche Schnittstelle, nss (RX, TX)
SoftwareSerial nss(2, 3);

// Variablen
float flat, flon;
unsigned long age;

void setup ()
{
  // Hardwareschnittstelle
  Serial.begin(9600);
  // GPS
  nss.begin(4800);
  // Ausgabe auf Schnittstelle
  Serial.println("GPS Modul");
  Serial.print("Suchen...");
}

void loop()
{
  while (nss.available())
  {
    // GPS-NMEA-Daten einlesen
    int c = nss.read();
    if (gps.encode(c))
    {
      gps.f_get_position(&flat, &flon, &age);
      // Ausgabe GPS Breitengrad
      Serial.print("Lat: ");
      Serial.println(flat);
      // Ausgabe GPS Längengrad
      Serial.print("Lon: ");
      Serial.print(flon);   
      }
  }
}

